package it.unicam.ids.RESTaurant4;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import it.unicam.ids.RESTaurant4.sala.entity.Tavolo;
import it.unicam.ids.RESTaurant4.sala.entity.TavoloRepository;
import it.unicam.ids.RESTaurant4.sala.service.Sala;

@Component
public class AppCommandLineRunner implements CommandLineRunner {

    private static final Logger log = LoggerFactory
			.getLogger(AppCommandLineRunner.class);

	@Autowired
	private TavoloRepository repository;

	@Autowired
	Sala sala;

	// @Override
	public void run(String... args) {
        // save a couple of customers
		repository.save(new Tavolo(4, "Bianca"));
		repository.save(new Tavolo(4, "Blu"));
		repository.save(new Tavolo(6, "Blu"));
		repository.save(new Tavolo(8, "Blu"));
		repository.save(new Tavolo(4, "Bianca"));
		repository.save(new Tavolo(6, "Bianca"));
		repository.save(new Tavolo(2, "Blu"));
		repository.save(new Tavolo(4, "Bianca"));
		repository.save(new Tavolo(10, "Bianca"));
		repository.save(new Tavolo(8, "Bianca"));
		repository.save(new Tavolo(2, "Bianca"));
		repository.save(new Tavolo(2, "Blu"));
		repository.save(new Tavolo(4, "Blu"));
		repository.save(new Tavolo(5, "Bianca"));
		repository.save(new Tavolo(4, "Bianca"));
		repository.save(new Tavolo(1, "Bianca"));
		repository.save(new Tavolo(2, "Bianca"));

		log.info("-------------------------------");
		log.info("Finding all the available tables");
		log.info("-------------------------------");
		for (Tavolo tavolo : repository.findAll()) {
			log.info(tavolo.toString());
        }

		sala.setSala(repository.findAll());

	}

}